/* fnvrand: a fast pseudo-random number generator
   v2003-09-01 / contact adam@gimp.org */
#ifndef _FNVRAND_H
#define _FNVRAND_H
/*
Copyright (C) 2002-2003 Adam D. Moss (the "Author").  All Rights Reserved.

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is fur-
nished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FIT-
NESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
AUTHOR BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CON-
NECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

Except as contained in this notice, the name of the Author of the
Software shall not be used in advertising or otherwise to promote the sale,
use or other dealings in this Software without prior written authorization
from the Author.
*/

/* Seed the random number generator */
void fnvsrand(unsigned long newseed);

/* Return (pseudo-)random numbers of various sizes.  For the best
   quality of randomness, use the closest returned type size larger
   than the number of random bits you desire. */
unsigned long  fnvrand32(void); /* Return a random 32-bit number */
unsigned short fnvrand16(void); /* ... 16-bit ... */
unsigned char  fnvrand8(void);  /* ... 8-bit ... */
unsigned char  fnvrand1(void);  /* ... 1-bit ... */

#endif
